"use strict";

var _polished = require("polished");

var _ansiStyles = require("ansi-styles");

var _ansiStyles2 = _interopRequireDefault(_ansiStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/* eslint-disable no-console */

var NodeConsole = require("console").Console;
var nodeConsole = new NodeConsole(process.stdout, process.stderr);


var COLOR_PREFIX = "color :";

var makeLogger = function makeLogger(func) {
  return function (first) {
    for (var _len = arguments.length, rest = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      rest[_key - 1] = arguments[_key];
    }

    if (typeof first !== "string") {
      return func.apply(undefined, [first].concat(_toConsumableArray(rest)));
    }
    rest = rest.filter(function (arg) {
      if (typeof arg !== "string") {
        return true;
      }
      if (!arg.startsWith("color: ")) {
        return true;
      }
      var code = void 0;
      var color = arg.substr(COLOR_PREFIX.length);
      if (color === "inherit") {
        code = _ansiStyles2.default.color.close;
      } else {
        try {
          var _parseToRgb = (0, _polished.parseToRgb)(color),
              red = _parseToRgb.red,
              green = _parseToRgb.green,
              blue = _parseToRgb.blue;

          code = _ansiStyles2.default.color.ansi256.rgb(red, green, blue);
        } catch (e) {
          code = _ansiStyles2.default.color.close;
        }
      }
      first = first.replace("%c", code);
      return false;
    });
    first += _ansiStyles2.default.color.close;
    return func.apply(undefined, [first].concat(_toConsumableArray(rest)));
  };
};

console.log = makeLogger(nodeConsole.log.bind(nodeConsole));
console.error = makeLogger(nodeConsole.error.bind(nodeConsole));

window.addEventListener("unhandledrejection", function (event) {
  console.error("Unhandled rejection (promise: ", event.promise, ", reason: ", event.reason, ").");
});
// console.error = (...args) => {
//   nodeConsole.error(args);
// };
// console.log = nodeConsole.log.bind(nodeConsole);
// console.error = nodeConsole.error.bind(nodeConsole);
//# sourceMappingURL=preload.js.map